class Prefix {
  final static String start = "<START>", end = "<END>", par = "<PAR>" ;

  // Le prfixe est un tableau de n mots.
  String [] t ;

  Prefix(int n) {
    t = new String [n] ;
    for (int k = 0 ; k < n ; k++)
      t[k] = start ;
  }

  // Glissement du prfixe.
  private Prefix(String [] t) {
    this.t = t ;
  }

  Prefix shift(String w) {
    int n = t.length ;
    String [] tt = new String [n] ;
    for (int k = 0 ; k < n-1 ; k++)
      tt[k] = t[k+1] ;
    tt[n-1] = w ;
    return new Prefix(tt) ;
  }

  /*****************/
  /* Redfinitions */
  /*****************/


  // Pas ncessaire, mais peut aider  mettre le programme au point.
  public String toString() {
    StringBuilder r = new StringBuilder () ;
    int n = t.length ;
    for (int k = 0 ; k < n-1 ; k++) {
      r.append(t[k]) ; r.append(" ") ;
    }
    r.append(t[n-1]) ;
    return r.toString() ;
  }

  // Suffisant en pratique : mlange des hashCode() des mots du prfixe.
  public int hashCode() {
    int r = 0 ;
    for (String s : t) {
      r += 37*r + s.hashCode() ;
    }
    return r ;
  }

  // galit structurelle des prfixes.
   public boolean equals(Object o) {
     Prefix op = (Prefix) o;
     int n = t.length ;
     for (int k = 0 ; k < n ; k++) {
       if (!t[k].equals(op.t[k])) return false ;
     }
     return true ;
  }
}
